import matplotlib.pyplot as plt
import matplotlib.patches as mpatches
import pandas as pd
import sys

# plots a graph comparing all attributes in a scatter plot

df = pd.read_csv(sys.argv[1])

colours = {'A.Echo': 'red', 'B.Netcam': 'purple', 'Camera': 'darkgreen', 'Hive': 'orange', 'Lamp': 'lime', 'S.Plug' : 'fuchsia', 'S.Things' : 'blue' }
fig = plt.figure()
fig.suptitle("Largest Packet Comparison (Bytes)")
titles = ["Total # Pkts", "Largest Pkt", "Smallest Pkt", "Largest Gap", "Smallest Gap", "Average Gap", "Class"]

count = 0
pos = 331

for i in df:
	ax = fig.add_subplot(pos)
	ax.scatter(df['L Pkt'], df[i], c = df['Class'].apply(lambda x: colours[x]), s = 10)
	ax.set_xlabel("Largest Packet", size = 7)
	ax.set_ylabel(titles[count], size = 7)
	plt.yticks(size = 7)
	plt.xticks(size = 7)
	count += 1
	pos += 1

A = mpatches.Patch(color='red', label='Amazon Echo')
B = mpatches.Patch(color='purple', label='Belking Netcam')
C = mpatches.Patch(color='darkgreen', label='Camera')
D = mpatches.Patch(color='orange', label='Hive')
E = mpatches.Patch(color='lime', label='Lamp')
F = mpatches.Patch(color='fuchsia', label='Smart Plug')
G = mpatches.Patch(color='blue', label='Smart Things')
ax = fig.add_subplot(pos)
ax = plt.legend(handles=[A, B, C, D, E, F, G], loc = 'center')
ax = plt.axis('off')

plt.show()