import matplotlib.pyplot as plt
import pandas as pd
import sys

# bar graph to show how accuracy is affected by attributes

df = pd.read_csv(sys.argv[1])
colours = ['turquoise', 'r', 'seagreen']

ax = df.plot(x=['Attribute'], y=["06Baseline"], kind="line", color = 'turquoise')
df.plot(x=['Attribute'], y=["16Baseline"], kind="line", ax = ax, color = 'r')
df.plot(x=['Attribute'], y=["21Baseline"], kind="line", ax = ax, color = 'seagreen')
df.plot.bar(x=['Attribute'], y = ['06Data', '16Data', '21Data'], ax = ax, color = colours)

ax.set_ylim(95,100)
ax.set_ylabel("Percentage Correctly Classified")
ax.set_xlabel("Attribute/s Removed")
ax.title.set_text("J48 Attribute Comparison")

plt.show()