import sys, csv, math
#Analyses the traffic by splitting up the data in a file to create multiple records.

# Finds the smallest and largest values in a given list
def smallAndLarge(l):
	largest = -math.inf
	smallest = math.inf
	for i in l:
		if float(i) > largest:
			largest = round(float(i), 4)
		if float(i) < smallest and round(float(i), 4) > 0:		
			smallest = round(float(i), 4)
	if smallest == math.inf:
		smallest = 0
	return (largest, smallest)

# Finds the mean value from a given list
def average(l):
	avg = 0
	if not l:
		print('No List Found')
	for i in l:
		avg = avg + float(i)
	avg = avg / len(l)
	return round(avg, 4)

# Finds the smallest, largest and average time gap within a given period
def burstiness(l, lim, star):
	n = 0
	m = 0
	l = l[star:lim]
	temp = []
	for i in range(0, len(l)-1):
		new = float(l[i+1]) - float(l[i])
		temp.append(new)
	if not temp:
		m = 0
		n = (0, 0)
	else:
		m = average(temp)
		n = smallAndLarge(temp)
	return n, m

# Prints the final values and writes them to a csv file
def statements(packetLim, packetStar):
	l = length[packetStar:packetLim]
	a = smallAndLarge(l)
	c = burstiness(packetTime, packetLim, packetStar)
	#print("Largest packet size: {}".format(a[0]))
	#print("Smallest packet size: {}".format(a[1]))
	#print("Largest time gap (sec): {}".format(c[0][0]))
	#print("Smallest time gap (sec): {}".format(c[0][1]))
	#print("Average time gap (sec): {}".format(c[1]))
	#print('\n------------------------------\n')

	#largest packet, smallest packet, largest gap, smallest gap, average gap
	data = '{}, {}, {}, {}, {},?\n'.format(a[0], a[1], c[0][0], c[0][1], c[1])
	newFile.write(data)




packetNumber = 0		#total number of packets sent/received in the file
packetTime = []			#the times that packets are sent/ received at
length = []				#packet sizes in bytes
timeLimit = 0			#limit for intervals in seconds
timeStart = 0			#starting point for interval in seconds
packetLim = 0

# reads the csv file as an argument					
with open(sys.argv[1]) as csvfile:
	reader = csv.DictReader(csvfile)
	for row in reader:
		packetTime.append(row['Time'])
		length.append(row['Length'])

# create header for new csv newFile					
newFile = open("E109.csv", 'a')
header = 'Total Pkts,L Pkt,S Pkt,L Gap,S Gap,A Gap,Class\n'
newFile.write(header)

# Get information within the time limit of the supplied csv
while timeLimit <= float(packetTime[-1]):
	
	# Break into 6 minute intervals
	timeStart = timeLimit
	timeLimit = timeLimit + 360

	# Get packet times within the correct range
	new = []
	for i in packetTime:
		if float(i) >= timeStart and float(i) < timeLimit:	
			new.append(i)
	packetStar = packetLim
	packetLim = packetStar + len(new)
	if new:
		packetNumber = len(new)	
		statements(packetLim, packetStar)

